.386p 

;option casemap:notpublic    
;   include vw32svc.inc
include vmm.inc 
include shell.inc
include fsdhookc.inc

;==========================================================================
;Copyright (C) 2004 Benito van der Zander
;This program is free software; you can redistribute it and/or modify
;it under the terms of the GNU General Public License as published by
;the Free Software Foundation; either version 2 of the License, or
;(at your option) any later version.

;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.

;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;==========================================================================

DECLARE_VIRTUAL_DEVICE FSDHOOK,1,0,FSDHOOK_Control, UNDEFINED_DEVICE_ID, UNDEFINED_INIT_ORDER

Begin_control_dispatch FSDHOOK
	Control_Dispatch W32_DEVICEIOCONTROL, OnIoControl
End_control_dispatch FSDHOOK
VxD_PAGEABLE_DATA_SEG
	MsgTitle db "FsdHook", 0
	StartInit db "load" ,0
	StopExit db "unload" ,0
	devio db "DeviceIoControl",0
VxD_PAGEABLE_DATA_ENDS


VxD_PAGEABLE_CODE_SEG

BeginProc OnIoControl
  EnterProc 
    push esi
    call _CIoControl
  LeaveProc 
  Return 
EndProc OnIoControl

BeginProc OnInit
  EnterProc 
   mov ecx, OFFSET32 StartInit        ; address of message text
   VMMCall Get_Cur_vm_handle          ; virtual machine handle
   mov eax,MB_OK+MB_ICONEXCLAMATION   ; message box flags
   mov edi, OFFSET32 MsgTitle         ; address of caption text
   xor esi,esi                        ; address of callback 
   xor edx,edx                        ; reference data for callback 
   VxDCall SHELL_sysmodal_Message

   call _CInit
  LeaveProc 
  Return 
EndProc OnInit

BeginProc OnExit
  EnterProc 
   mov ecx, OFFSET32 StopExit         ; address of message text
   VMMCall Get_Cur_vm_handle          ; virtual machine handle
   mov eax,MB_OK+MB_ICONEXCLAMATION   ; message box flags
   mov edi, OFFSET32 MsgTitle         ; address of caption text
   xor esi,esi                        ; address of callback 
   xor edx,edx                        ; reference data for callback 
   VxDCall SHELL_sysmodal_Message
   call _CExit
  LeaveProc 
  Return 
EndProc OnExit

VxD_PAGEABLE_CODE_ENDS

end
