.386p 
include basedef.inc 
include vmm.inc 
include shell.inc

;==========================================================================
;Copyright (C) 2004 Benito van der Zander

;This program is free software; you can redistribute it and/or modify
;it under the terms of the GNU General Public License as published by
;the Free Software Foundation; either version 2 of the License, or
;(at your option) any later version.

;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.

;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;==========================================================================

include ifsmgr.inc
VxD_PAGEABLE_DATA_SEG
	MsgTitle db "FsdHook", 0
	StartInit db "load" ,0
	StopExit db "unload" ,0
	devio db "t2",0
VxD_PAGEABLE_DATA_ENDS
VxD_PAGEABLE_CODE_SEG
BeginProc _IFSMgr_InstallFileSystemApiHookWrap ;Address in eax, result, too
  push eax
  VxDCall IFSMgr_InstallFileSystemApiHook
  pop ecx
  mov eax, [eax]
  ret
EndProc _IFSMgr_InstallFileSystemApiHookWrap

BeginProc _IFSMgr_RemoveFileSystemApiHookWrap ;Address in eax, too
  push eax
  VxDCall IFSMgr_RemoveFileSystemApiHook
  pop eax
  ret
EndProc _IFSMgr_RemoveFileSystemApiHookWrap

BeginProc _IFSMgr_Ring0_FileIOWrap
  VxDCall IFSMgr_Ring0_FileIO
	ret
EndProc _IFSMgr_Ring0_FileIOWrap

BeginProc _UniToBCSPathWrap ;charset in eax (result after exit), len in ecx, unipath pointer in esi, bcspointer in edi
  push eax ;Store arguments
  push ecx
  push esi
  push edi
  VxDCall UniToBCSPath
  pop ecx ;free stack
  pop ecx
  pop ecx
  pop ecx
  ret
EndProc _UniToBCSPathWrap

BeginProc _UniToBCSWrap 
  ;Store arguments:, len in ecx,  bcspointer in edi
  push eax ;charset in eax (converted bytes after exit)
  push ecx ;maximum length in bytes of the destination buffer, excluding NUL character. 
  push edx ;Supplies the length in bytes of the unicode input string. 
  push esi ;uni pointer in esi
  push edi ;bcspointer in edi
  VxDCall UniToBCS
  pop ecx ;free stack
  pop ecx
  pop ecx
  pop ecx
  pop ecx
  ret
EndProc _UniToBCSWrap

BeginProc _BCSToUniWrap 
  ;Store arguments:, len in ecx,  bcspointer in edi
  push eax ;charset in eax (converted bytes after exit)
  push ecx ;Supplies the length in bytes of the BCS input string. 
  push esi ;bcs pointer in esi
  push edi ;unipointer in edi
  VxDCall BCSToUni
  pop ecx ;free stack
  pop ecx
  pop ecx
  pop ecx
  ret
EndProc _BCSToUniWrap


BeginProc _IFSMgr_Win32ToDosTimeWrap 
  VxDCall IFSMgr_Win32ToDosTime
  ret
EndProc _IFSMgr_Win32ToDosTimeWrap

BeginProc _LinPageLockWrap ;eax: startpage, ecx: len
  VMMCall _LinPageLock, <eax,ecx, 0>
  ret
EndProc _LinPageLockWrap

BeginProc _LinPageUnLockWrap ;eax: startpage, ecx: len
  VMMCall _LinPageUnLock, <eax,ecx, 0>
  ret
EndProc _LinPageUnLockWrap


VxD_PAGEABLE_CODE_ENDS

end
